package de.hhu.ba.yoshikoWrapper.core;

public class YoshikoLoader {
	
	//SINGLETON TEMPLATE
	
	private static YoshikoLoader instance;
	private static boolean libraryLoaded;
	
	public static YoshikoLoader getInstance() {
		if (instance == null){
			instance = new YoshikoLoader();
		}
		return instance;
	}
	
	private YoshikoLoader() {
		libraryLoaded = false;
	}
	

	public void loadLibrary() {
		if (libraryLoaded) {
			return;
		}
		try {
			System.loadLibrary("libyoshikoLibrary");
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	

	public void loadLibrary(String libPath) {
		if (libraryLoaded) {
			return;
		}
		try {
			System.load(libPath);
			libraryLoaded = true;
		}
		catch(UnsatisfiedLinkError e) {
			e.printStackTrace();
			libraryLoaded = false;
		}
		finally {
			
		}

	}
	
	//SETTER / GETTER
	
	public boolean isLibraryLoaded() {
		return libraryLoaded;
	}

}
